﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using Telerik.Windows;
using Telerik.Windows.Controls.DragDrop;
using System.Collections;
using Telerik.Windows.Controls.TreeView;

namespace TreeViewDNDOntheSAmeItem
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            radTreeView.ExpandAll();
            radTreeView.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));
        }

        private void OnDragInfo(object sender, DragDropEventArgs e)
        {
            if (e.Options.Status == DragStatus.DragCancel)
            {
                // MessageBox.Show(((e.Options.Destination as RadTreeViewItem).Item == (e.Options.Source as RadTreeViewItem).ParentItem).ToString());
                MessageBoxResult result = MessageBox.Show("Invalid operation. Proceed with adding a copy here ?", "Warning!", MessageBoxButton.OKCancel);
                if (result == MessageBoxResult.OK)
                {        
                    RadTreeViewItem destItem = e.Options.Destination as RadTreeViewItem;
                    RadTreeViewItem copyItem = new RadTreeViewItem()
                    {
                        Header = ((e.Options.Payload as IList)[0] as RadTreeViewItem).Header
                    };
                    destItem.Items.Add(copyItem);
                }
            }
        }

        private void radTreeView_PreviewDragEnded(object sender, Telerik.Windows.Controls.RadTreeViewDragEndedEventArgs e)
        {
            e.Handled = true;
            foreach (object item in e.DraggedItems)
            {
                RadTreeViewItem treeItem = new RadTreeViewItem();
                treeItem.Header = (item as RadTreeViewItem).Header;

                switch (e.DropPosition)
                {
                    case DropPosition.After:
                        if (e.TargetDropItem.ParentItem != null)
                        {
                            e.TargetDropItem.ParentItem.Items.Insert(e.TargetDropItem.Index + 1, treeItem);
                        }
                        else
                            e.TargetDropItem.ParentTreeView.Items.Insert(e.TargetDropItem.Index + 1, treeItem);
                        break;
                    case DropPosition.Before:
                        if (e.TargetDropItem.ParentItem != null)
                        {
                            e.TargetDropItem.ParentItem.Items.Insert(e.TargetDropItem.Index, treeItem);
                        }
                        else
                            e.TargetDropItem.ParentTreeView.Items.Insert(e.TargetDropItem.Index, treeItem);
                        break;
                    case DropPosition.Inside:
                        e.TargetDropItem.Items.Add(treeItem);
                        break;
                    default:
                        e.TargetDropItem.Items.Add(treeItem);
                        break;
                }
            }
        }
    }
}
